#pragma once

#include <vector>


class CombUCBStep
{
public:
    /// Constructor.
    CombUCBStep(int numArms, int sizeSubset);

    /// Destructor.
    ~CombUCBStep();

    /// Take actions.
    std::vector<size_t> getBestSupArm();

    /// Update best actions.
    void updateBestSupArm();

    /// Update stats.
    void receiveReward(size_t arm, double reward);
    double increaseTime();

protected:
    int numArms;
    int sizeSubset;
    double times;

    std::vector<double> numPulls;
    std::vector<double> empiricalMeans;
    std::vector<size_t> prevBestSupArm;
};