#pragma once

#include <vector>


class CombUCB
{
public:
    /// Constructor.
    CombUCB(int numArms, int sizeSubset);

    /// Destructor.
    ~CombUCB();

    /// Take actions.
    std::vector<size_t> getBestSupArm();

    /// Update stats.
    void receiveReward(size_t arm, double reward);
    double increaseTime();

protected:
    int numArms;
    int sizeSubset;
    double times;

    std::vector<double> numPulls;
    std::vector<double> empiricalMeans;
};